      subroutine detav( period, rhoxx, phaxx, rhoxy, phaxy, 
     &            rhoyx, phayx, rhoyy, phayy, rho, pha )
c-----------------------------------------------------------------------

c      implicit none

c-----------------------------------------------------------------------

      real PI, MU, PIMU

      parameter  (  PI     = 3.141592 )
      parameter  (  MU     = 4.*PI*1.E-7 )
      parameter  (  PIMU   = PI * MU )

c-----------------------------------------------------------------------

      real period, rhoxx, phaxx, rhoxy, phaxy, rhoyx, phayx, 
     &             rhoyy, phayy, rho, pha, zm, ang
      complex zxx, zxy, zyx, zyy, z

c-----------------------------------------------------------------------

      if( rhoxx.ne.0. ) then
        zm = sqrt( 2. * PIMU * abs(rhoxx) / period )
        zxx = cmplx( (zm*cosd(phaxx)), (zm*sind(phaxx)) )
      else
        zxx = cmplx( 0., 0. )
      end if

      zm = sqrt( 2. * PIMU * abs(rhoxy) / period )
      zxy = cmplx( (zm*cosd(phaxy)), (zm*sind(phaxy)) )

      zm = sqrt( 2. * PIMU * abs(rhoyx) / period )
      zyx = cmplx( (zm*cosd(phayx)), (zm*sind(phayx)) )

      if( rhoyy.ne.0. ) then
        zm = sqrt( 2. * PIMU * abs(rhoyy) / period )
        zyy = cmplx( (zm*cosd(phayy)), (zm*sind(phayy)) )
      else
        zyy = cmplx( 0., 0. )
      end if

      z = csqrt( zxx*zyy - zxy*zyx )
      rho = period * real( z * conjg(z) ) / ( 2. * PIMU )
      pha = atan2d( aimag(z), real(z) )

      if( (rhoxx.lt.0.)  .or. (rhoxy.lt.0.) .or.
     &    (rhoyx.lt.0.)  .or. (rhoyy.lt.0.)      ) rho = -rho

      return
      end
