c           complex zxx,zxy,zyx,zyy,lama,lamb
c           real ornta,orntb,ella,ellb
c
c           CALL EGGERS(zxx,zxy,zyx,zyy,lama,lamb,ornta,orntb,ella,ellb)
c
c
c            stop 
c            end


c***********************************************************************
c
c EGGERS PARAMETERS -  2 complex eigenvalues, lama,lamb
c                  -  2 orientations of electric eigenvectors - ornta,orntb
c                  -  2 orientations of electric eigenvectors - ella,ellb   
c  
c Note: Orientations of +/- 189 or Ellipticities of +/- 9 indicate
c       information is not present in the data
c
c**********************************************************************

        subroutine EGGERS(zxx,zxy,zyx,zyy,lama,lamb,ornta,
     >orntb,ella,ellb)

       complex zmeas(2,2),lambda(2),zz(4),det
       complex lama,lamb,zxx,zxy,zyx,zyy
       complex heigen(2,2),eeigen(2,2)
       complex eplus(2),emin(2),skellip(2)

       real ornta,orntb,ella,ellb
       real orient(2),ellip(2)
       REAL EMAG(2)
       
         zmeas(1,1)=zxx
         zmeas(1,2)=zxy
         zmeas(2,1)=zyx
         zmeas(2,2)=zyy


        det=zmeas(1,1)*zmeas(2,2)-zmeas(1,2)*zmeas(2,1)
        zz(1)=(zmeas(1,2)-zmeas(2,1))/2.

       
       lambda(1)=zz(1)+csqrt( zz(1)*zz(1)-det)
       lambda(2)=zz(1)-csqrt( zz(1)*zz(1)-det)


        heigen(1,1)=lambda(1)-zmeas(1,2)
        heigen(2,1)=zmeas(1,1)
        heigen(1,2)=lambda(2)-zmeas(1,2)
        heigen(2,2)=zmeas(1,1)
        eeigen(2,1)=lambda(2)+zmeas(2,1)
        eeigen(1,1)=zmeas(1,1)
        eeigen(2,2)=lambda(1)+zmeas(2,1)
        eeigen(1,2)=zmeas(1,1)


        eplus(1)=(eeigen(1,1)-cmplx(0.,1.)*eeigen(2,1))/sqrt(2.)
        eplus(2)=(eeigen(1,2)-cmplx(0.,1.)*eeigen(2,2))/sqrt(2.)
        emin(1)=(eeigen(1,1)+cmplx(0.,1.)*eeigen(2,1))/sqrt(2.)
        emin(2)=(eeigen(1,2)+cmplx(0.,1.)*eeigen(2,2))/sqrt(2.)

        EMAG(1)=CABS(EPLUS(1))
        EMAG(2)=CABS(EPLUS(2))
                 
c check for singularities        
        IF(EMAG(1).GT.(0.0001))THEN
          skellip(1)=emin(1)/eplus(1)

            IF(SKELLIP(1).NE.(0.0))THEN
    

            call dbletan(real(skellip(1)),aimag(skellip(1)),orient(1))

           

            ELSE
             IF( (AIMAG(SKELLIP(1))*REAL(SKELLIP(1)) ).GT.(0.0) )THEN
              ORIENT(1)=45.
             ELSE
              ORIENT(1)=-45.
             END IF
            END IF

            r=cabs(skellip(1))

            IF( R.NE.(-1.) )THEN
              ellip(1)=abs(1.-r)/(1.+r)
            ELSE
              ELLIP(1)=9.
            END IF

         ELSE

          ORIENT(1)=-189.99
          IF(EMIN(1).EQ.(0.))THEN
            ELLIP(1)=-9.
          ELSE
            ELLIP(1)=9.
          END IF

         END IF

ccheck for singularities         
        IF(EMAG(2).GT.(0.0001))THEN

          skellip(2)=emin(2)/eplus(2)

        IF(SKELLIP(2).NE.(0.0))THEN
          call dbletan(real(skellip(2)),aimag(skellip(2)),orient(2))


        ELSE
          IF( (AIMAG(SKELLIP(2))*REAL(SKELLIP(2)) ).GT.(0.0) )THEN
            ORIENT(2)=45.
          ELSE
            ORIENT(2)=-45.
          END IF
        END IF

          r=cabs(skellip(2))

         IF( R.NE.(-1.) )THEN
          ellip(2)=abs(1.-r)/(1.+r)
         ELSE
          ELLIP(2)=9.
         END IF


        ELSE

          ORIENT(2)=-189.99
          IF(EMIN(2).EQ.(0.))THEN
            ELLIP(2)=-9.
          ELSE
            ELLIP(2)=9.
          END IF
        END IF
            
        lama=lambda(1)
        lamb=lambda(2)
        ornta=orient(1)
        orntb=orient(2)
        ella=ellip(1)
        ellb=ellip(2)        

        return 
        end

c*******************************************************************
c
c  subroutine double angle inverse tan
c
c**************************************************************

      subroutine dbletan(x,y,nphi)

       real x,y,nphi

      if(x.ne.0.)then

       theta=atand(y/x)


      if( ((sind(theta).gt.0.).and.(y.lt.0) ).or.
     >( (sind(theta).lt.0).and.(y.gt.0) ) )then

         chi=theta+180.

      else
     
         chi=theta
   
      end if

        else

          if(y.ge.0.)chi=90.
          if(y.lt.0.)chi=-90.

        end if


        if(y.eq.0.)then
           if(x.ge.0.)chi=0.
           if(x.lt.0.)chi=180.
        end if
          
        nphi=chi/2.

        if(nphi.gt.90)nphi=nphi-180.
        if(nphi.lt.(-90.))nphi=nphi+180.



         return
         end


