      subroutine zconv( itype, z, rho, phase, period)

c      implicit none

      complex z
      integer itype, ndev, ndevm
      real MU, pi, rho, phase, period, zm, ang, omega

      common /nwrite/ ndev,ndevm

      parameter( PI = 3.141592 , MU = 4.*PI*1.e-7 )
C 
C    CONVERTS  ITYPE = 1    Z -> RHO,PHASE
C                      2    RHO,PHASE -> Z
C 
C     NOTE THAT 'Z' MUST BE IN S.I. - NOT FIELD UNITS
c     E-field in Volt/meter ; B-field in Tesla
c
c                                  2
c     rho_a = (mu/omega)  | E / B |
c               
c     
C 
      IF( NDEVM .NE. 0 ) WRITE(NDEVM,3333) itype
 3333 FORMAT(5X,'==>SUBROUTINE ZCONV ENTERED, itype=',i1 )
C 
      omega = 2.*PI/period

      goto (1,2),itype
      rho=-9999.
      phase=-9999.
      return
C 
    1 rho = MU * real(z*conjg(z)) / omega
      phase = atan2d( aimag(z), real(z) )
      return
C 
    2 zm = sqrt(omega*rho/MU)
      z = cmplx(zm*cosd(phase),zm*sind(phase))
      return
      end
